import { CheckboxSOP } from '../../libappsop/checkboxsop';
import { FormSOP } from '../../libappsop/formsop';
import { ListSOP } from '../../libappsop/listsop';
import { DialogDummy } from '../dialogs/dialog.dummy';

export class FormTripPlanDetails extends FormSOP {
  public static readonly title = 'Trip Plan Details';
  public listTripPlanDetails = new ListTripPlanDetails();
  public cbFilterByTransportationPlan = new CheckboxSOP('CheckboxToggleButton');

  public constructor() {
    super('FormTripPlanDetails');
  }
}

export class ListTripPlanDetails extends ListSOP<DialogDummy, ListTripPlanningColumn> {
  public static readonly title = 'Trip Plan Details';

  public constructor() {
    super('ListTrips', new DialogDummy());
    // Set primary key column name(s), to display in error message when assert fails
    this.rowPrimaryColumnNames = { Unit: '', Departure: '', Arrival: '', Origin: '', Destination: '' };
  }
}

// Although form (and not dialog), we create the interface so that spec script can use for step description (e.g calling StepDialog related method to use in "it")
export interface FormTripPlanningFields {
  ToggleFilterByTransportationPlan: boolean;
}

export interface ListTripPlanningColumn {
  Unit?: string;
  Departure?: string;
  Arrival?: string;
  Origin?: string;
  Destination?: string;
  LeadTime?: string;
  UnitOfMeasurement?: string;
  Load?: string;
  Symbol?: string;
  Cost?: string;
}
